classdef Plant < handle

    properties (SetAccess = private, GetAccess = public)
        iter  = 0
        
        nx
        nu
        ny
        
        x_init = [0;0] 
        x_current
        
        A
        B
        C
    end


    methods (Access = public)

      function self = Plant(A, B, C)
          self.A = A;
          self.B = B;
          self.C = C;  
          
          self.nx = size(A, 1);
          self.nu = size(B, 2);
          self.ny = size(C, 2);
      end
      
      function [] = init(self)
         
          self.x_current = self.x_init;
      end
      


      function [y, x_true] = step(self, u)

        self.iter = self.iter + 1; % iteration
        
        x_true = self.x_current;
        y = self.C * self.x_current;
        
        self.x_current = self.A * self.x_current + self.B*u + 0.1*ones(self.nx,1);
        
      end
    end
    

end